# -*- coding: utf-8 mode: sh -*- vim:sw=4:sts=4:et:ai:si:sta:fenc=utf-8

function __esection() {
    local -a lines
    local lsep prefix="$(__edate)$(__eindent0)"
    local length="${COLUMNS:-80}"
    setx lsep=__complete "$prefix" "$length" -

    recho "$COULEUR_BLEUE$lsep$COULEUR_NORMALE"
    [ -n "$*" ] || return 0
    length=$((length - 1))
    setx -a lines=echo "$1"
    for line in "${lines[@]}"; do
        setx line=__complete "$prefix- $line" "$length"
        recho "$COULEUR_BLEUE$line-$COULEUR_NORMALE"
    done
    recho "$COULEUR_BLEUE$lsep$COULEUR_NORMALE"
}
function __etitle() {
    local -a lines; local maxlen=0
    local prefix="$(__edate)$(__eindent0)"
    
    setx -a lines=echo "$1"
    for line in "${lines[@]}"; do
        [ ${#line} -gt $maxlen ] && maxlen=${#line}
        recho "${prefix}${COULEUR_BLEUE}T $line$COULEUR_NORMALE"
    done
    maxlen=$((maxlen + 2))
    recho "${prefix}${COULEUR_BLEUE}T$(__complete "" $maxlen -)${COULEUR_NORMALE}"
}
function __edesc() {
    local -a lines
    local prefix="$(__edate)$(__eindent0)"
    
    setx -a lines=echo "$1"
    for line in "${lines[@]}"; do
        recho "${prefix}${COULEUR_BLEUE}>${COULEUR_NORMALE} $line"
    done
}
function __ebanner() {
    local -a lines
    local lsep prefix="$(__edate)$(__eindent0)"
    local length="${COLUMNS:-80}"
    setx lsep=__complete "$prefix" "$length" =

    recho "$COULEUR_ROUGE$lsep"
    length=$((length - 1))
    setx -a lines=echo "$1"
    for line in "" "${lines[@]}" ""; do
        setx line=__complete "$prefix= $line" "$length"
        recho "$line="
    done
    recho "$lsep$COULEUR_NORMALE"
}
function __eimportant() { recho "$(__edate)$(__eindent0)${COULEUR_ROUGE}!${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __eattention() { recho "$(__edate)$(__eindent0)${COULEUR_JAUNE}*${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __eerror() { recho "$(__edate)$(__eindent0)${COULEUR_ROUGE}E${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __ewarn() { recho "$(__edate)$(__eindent0)${COULEUR_JAUNE}W${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __enote() { recho "$(__edate)$(__eindent0)${COULEUR_VERTE}N${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __einfo() { recho "$(__edate)$(__eindent0)${COULEUR_BLEUE}I${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __edebug() { recho "$(__edate)$(__eindent0)${COULEUR_BLANCHE}D${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }

function __estep() { recho "$(__edate)$(__eindent0)${COULEUR_BLANCHE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __estepe() { recho "$(__edate)$(__eindent0)${COULEUR_ROUGE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __estepw() { recho "$(__edate)$(__eindent0)${COULEUR_JAUNE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __estepn() { recho "$(__edate)$(__eindent0)${COULEUR_VERTE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __estepi() { recho "$(__edate)$(__eindent0)${COULEUR_BLEUE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __estep_() { recho_ "$(__edate)$(__eindent0)${COULEUR_BLANCHE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __estepe_() { recho_ "$(__edate)$(__eindent0)${COULEUR_ROUGE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __estepw_() { recho_ "$(__edate)$(__eindent0)${COULEUR_JAUNE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __estepn_() { recho_ "$(__edate)$(__eindent0)${COULEUR_VERTE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __estepi_() { recho_ "$(__edate)$(__eindent0)${COULEUR_BLEUE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }

function __action() { recho "$(__edate)$(__eindent0)${COULEUR_BLANCHE}.${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __asuccess() { recho "$(__edate)$(__eindent0)${COULEUR_VERTE}✔${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __afailure() { recho "$(__edate)$(__eindent0)${COULEUR_ROUGE}✘${COULEUR_NORMALE} $(__eindent "$1" "  ")"; }
function __adone() { recho "$(__edate)$(__eindent0)$(__eindent "$1")"; }
