<?php
namespace nulib\db\pdo;

use nulib\php\nur_func;

class _config {
  static function with($configs): self {
    if ($configs instanceof static) return $configs;
    return new static($configs);
  }

  const CONFIG = null;

  function __construct($configs) {
    if ($configs === null) $configs = static::CONFIG;
    if ($configs === null) $configs = [];
    elseif (is_string($configs)) $configs = [$configs];
    elseif (is_callable($configs)) $configs = [$configs];
    elseif (!is_array($configs)) $configs = [strval($configs)];
    $this->configs = $configs;
  }

  /** @var array */
  protected $configs;

  function configure(Pdo $pdo): void {
    foreach ($this->configs as $key => $config) {
      if (is_string($config) && !nur_func::is_method($config)) {
        $pdo->exec($config);
      } else {
        nur_func::ensure_func($config, $this, $args);
        nur_func::call($config, $pdo, $key, ...$args);
      }
    }
  }
}
